package com.btcpiyush.ads.google_applovin_unity_ads.banner_ad

import android.app.Activity
import com.btcpiyush.ads.google_applovin_unity_ads.GoogleApplovinUnityAdsPlugin
import com.btcpiyush.ads.google_applovin_unity_ads.api.AppSettings
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel

data class AdMobBanner (
    private val flutterPluginBinding: FlutterPlugin.FlutterPluginBinding,
    private val act: Activity,
    private val settingResponse: AppSettings
        ) :
    MethodChannel.MethodCallHandler {

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        when (call.method) {
            GoogleApplovinUnityAdsPlugin.METHOD_LOAD_BANNER_ADS -> {
                val id = call.argument<String>("id")
                loadBannerAd(id)
            }
            GoogleApplovinUnityAdsPlugin.METHOD_DISPOSE_BANNER_ADS -> {
                val id = call.argument<String>("id")
                destroyBannerAd(id)
            }
        }
    }

    private fun loadBannerAd(call_id: String?) {
        if (settingResponse.googleAds?.isBannerAds == true ||
            settingResponse.appLovin?.isBannerAds == true ||
            settingResponse.customAds?.isBannerAds == true ||
            settingResponse.unityAds?.isBannerAds == true
        ) {
            if (flutterPluginBinding.binaryMessenger != null) {
                if (call_id != null) {
                    BannerAdControllerManager.createController(
                        GoogleApplovinUnityAdsPlugin.appLovinSDK,
                        call_id,
                        flutterPluginBinding.binaryMessenger,
                        act
                    )
                }
            }
        }
    }

    private fun destroyBannerAd(call_id: String?) {
        if (call_id != null) {
            val id = call_id
            BannerAdControllerManager.getController(id)?.adMobBannerView?.destroy()
            try {
                BannerAdControllerManager.getController(id)?.bannerAdView?.removeAllViews()
            } catch (e: Exception) {
            }
            try {
                BannerAdControllerManager.removeController(id)
            } catch (e: Exception) {
            }
        }

    }

}