import 'dart:async';

import 'package:flutter/services.dart';
import 'package:google_applovin_unity_ads/events/admob_events.dart';


abstract class AdmobEventHandler {
  final Function(AdmobAdEvent, Map<String, dynamic>?)? _listener;

  AdmobEventHandler(Function(AdmobAdEvent, Map<String, dynamic>?)? listener)
      : _listener = listener;

  Future<void> handleEvent(MethodCall call) async {

    if (_listener == null) {
      return;
    }
    print("EVENT HANDLER ---> ${call.method}   _listener ---> $_listener");
    switch (call.method) {
      case 'success':
      case 'SUCCESS':
        _listener!(AdmobAdEvent.success, null);
        break;
      case 'error':
      case 'ERROR':
        print("EVENT HANDLER ---> ${call.method}   _listener ---> $_listener");
        _listener!(AdmobAdEvent.error, null);
        break;
    }
  }
}
